/****************************************************
	MARC Template Library 

	Version 0.6.2 - Released 14 June 2002 
 	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
	  Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
  Version 0.4 - Released 28th March 2002
  Version 0.3 - Released 18th January 2002
  Version 0.2 - Released 14th January 2002
  Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/

#include "marc8xmlentity.h"
#include <iostream>



MARC8_XMLEntity::EntityTable MARC8_XMLEntity::entitytable[] = {
	{128, 0, 0}, 
	{129, 0, 0}, 
	{130, 0, 0},
	{131, 0, 0},
	{132, 0, 0},
	{133, 0, 0},
	{134, 0, 0},
	{135, 0, 0},
	{136, 0, 0}, //"&#152;"}, // 88    0098    NON-SORT BEGIN / START OF STRING
	{137, 0, 0}, // "&#156;"}, // 89    009C    NON-SORT END / STRING TERMINATOR
	{138, 0, 0}, 
	{139, 0, 0},
	{140, 0, 0},
	{141, 0, "&#8205;"}, // 8D    200D    JOINER / ZERO WIDTH JOINER
	{142, 0, "&#8204;"}, // 8E    200C    NON-JOINER / ZERO WIDTH NON-JOINER
	{143, 0, 0},
	{144, 0, 0},
	{145, 0, 0},
	{146, 0, 0},
	{147, 0, 0},
	{148, 0, 0}, 
	{149, 0, 0},
	{150, 0, 0},
	{151, 0, 0},
	{152, 0, 0},
	{153, 0, 0},
	{154, 0, 0},
	{155, 0, 0},
	{156, 0, 0},
	{157, 0, 0},
	{158, 0, 0}, 
	{159, 0, 0},
	{160, 0, 0},
	{161, 0, "&#321;"}, // A1 0141  UPPERCASE POLISH L / LATIN CAPITAL LETTER L WITH STROKE 
	{162, 0, "&#216;"}, // A2 00D8 UPPERCASE SCANDINAVIAN O / LATIN CAPITAL LETTER O WITH STROKE 
	{163, 0, "&#272;"}, // A3 0110 UPPERCASE D WITH CROSSBAR / LATIN CAPITAL LETTER D WITH STROKE 
	{164, 0, "&#222;"}, // A4 00DE UPPERCASE ICELANDIC THORN / LATIN CAPITAL LETTER THORN (Icelandic)
	{165, 0, "&#198;"}, // A5 00C6 UPPERCASE DIGRAPH AE / LATIN CAPITAL LIGATURE AE 
	{166, 0, "&#338;"}, // A6 0152 UPPERCASE DIGRAPH OE / LATIN CAPITAL LIGATURE OE 
	{167, 0, "&#697;"}, // A7 02B9 SOFT SIGN, PRIME / MODIFIER LETTER PRIME
	{168, 0, "&#183;"}, // A8  00B7 MIDDLE DOT
	{169, 0, "&#557;"}, // A9 266D MUSIC FLAT SIGN
	{170, 0, "&#174;"}, // AA  00AE  PATENT MARK / REGISTERED SIGN 
	{171, 0, "&#177;"}, // AB  00B1  PLUS OR MINUS / PLUS-MINUS SIGN
	{172, 0, "&#416;"}, // AC 01A0 UPPERCASE O-HOOK / LATIN CAPITAL LETTER O WITH HORN
	{173, 0, "&#431;"}, // AD 01AF UPPERCASE U-HOOK / LATIN CAPITAL LETTER U WITH HORN
	{174, 0, "&#702;"}, // AE  02BE  ALIF / MODIFIER LETTER RIGHT HALF RING 
	{175, 0, 0}, 
	{176, 0, "&#699;"}, // B0 02BB AYN / MODIFIER LETTER TURNED COMMA
	{177, 0, "&#322;"}, // B1 0142 LOWERCASE POLISH L / LATIN SMALL LETTER L WITH STROKE 
	{178, 0, "&#248;"}, // B2 00F8 LOWERCASE SCANDINAVIAN O / LATIN SMALL LETTER O WITH STROKE 
	{179, 0, "&#273;"}, // B3 0111 LOWERCASE D WITH CROSSBAR / LATIN SMALL LETTER D WITH STROKE 
	{180, 0, "&#254;"}, // B4 00FE LOWERCASE ICELANDIC THORN / LATIN SMALL LETTER THORN (Icelandic) 
	{181, 0, "&#230;"}, // B5 00E6 LOWERCASE DIGRAPH AE / LATIN SMALL LIGATURE AE
	{182, 0, "&#339;"}, // B6 0153  LOWERCASE DIGRAPH OE / LATIN SMALL LIGATURE OE 
	{183, 0, "&#698;"}, // B7 02BA HARD SIGN, DOUBLE PRIME / MODIFIER LETTER DOUBLE PRIME 
	{184, 0, "&#305;"}, // B8 0131 LOWERCASE TURKISH I / LATIN SMALL LETTER DOTLESS I 
	{185, 0, "&#163;"}, // B9 00A3 BRITISH POUND / POUND SIGN 
	{186, 0, "&#240;"}, // BA  00F0 LOWERCASE ETH / LATIN SMALL LETTER ETH (Icelandic) 
	{187, 0, 0},
	{188, 0, "&#417;"}, // BC  01A1  LOWERCASE O-HOOK / LATIN SMALL LETTER O WITH HORN 
	{189, 0, "&#432;"}, // BD 01B0 LOWERCASE U-HOOK / LATIN SMALL LETTER U WITH HORN 
	{190, 0, 0},
	{191, 0, 0},
	{192, 0, "&#176;"}, // C0  00B0  DEGREE SIGN 
	{193, 0, "&#8467;"}, // C1  2113  SCRIPT SMALL L 
	{194, 0, "&#8471;"}, // C2  2117  SOUND RECORDING COPYRIGHT 
	{195, 0, "&#179;"}, // C3  00A9  COPYRIGHT SIGN 
	{196, 0, "&#9839;"}, // C4  266F  MUSIC SHARP SIGN 
	{197, 0, "&#191;"}, // C5  00BF  INVERTED QUESTION MARK 
	{198, 0, "&#161;"}, // C6  00A1  INVERTED EXCLAMATION MARK 
	{199, 0, 0},
	{200, 0, 0},
	{201, 0, 0},
	{202, 0, 0},
	{203, 0, 0},
	{204, 0, 0},
	{205, 0, 0},
	{206, 0, 0},
	{207, 0, 0},
	{208, 0, 0},
	{209, 0, 0},
	{210, 0, 0},
	{211, 0, 0},
	{212, 0, 0},
	{213, 0, 0},
	{214, 0, 0},
	{215, 0, 0},
	{216, 0, 0},
	{217, 0, 0},
	{218, 0, 0},
	{219, 0, 0},
	{220, 0, 0},
	{221, 0, 0},
	{222, 0, 0},
	{223, 0, 0},
	{224, 0, "&#777;"}, // E0 0309  PSEUDO QUESTION MARK / COMBINING HOOK ABOVE 
	{225, 0, "&#768;"}, // E1 0300 GRAVE / COMBINING GRAVE ACCENT (Varia)
	{226, 0, "&#769;"}, // E2  0301 ACUTE / COMBINING ACUTE ACCENT (Oxia)
	{227, 0, "&#770;"}, // E3 0302 CIRCUMFLEX / COMBINING CIRCUMFLEX ACCENT
	{228, 0, "&#771;"}, // E4  0303  TILDE / COMBINING TILDE
	{229, 0, "&#772;"}, // E5  0304  MACRON / COMBINING MACRON
	{230, 0, "&#774;"}, // E6  0306  BREVE / COMBINING BREVE (Vrachy) 
	{231, 0, "&#775;"}, // E7 0307 SUPERIOR DOT / COMBINING DOT ABOVE 
	{232, 0, "&#776;"}, // E8  0308  UMLAUT, DIAERESIS / COMBINING DIAERESIS (Dialytika) 
	{233, 0, "&#780;"}, // E9 030C HACEK / COMBINING CARON 
	{234, 0, "&#778;"}, // EA  030A  CIRCLE ABOVE, ANGSTROM / COMBINING RING ABOVE
	{235, 0, "&#65056;"}, // EB  FE20 LIGATURE, FIRST HALF / COMBINING LIGATURE LEFT HALF 
	{236, 0, "&#65057;"}, // EC  FE21 LIGATURE, SECOND HALF / COMBINING LIGATURE RIGHT HALF 
	{237, 0, "&#789;"}, // ED  0315  HIGH COMMA, OFF CENTER / COMBINING COMMA ABOVE RIGHT
	{238, 0, "&#779;"}, // EE  030B  DOUBLE ACUTE / COMBINING DOUBLE ACUTE ACCENT
	{239, 0, "&#784;"}, // EF  0310  CANDRABINDU / COMBINING CANDRABINDU 
	{240, 0, "&#807;"}, // F0  0327  CEDILLA / COMBINING CEDILLA 
	{241, 0, "&#808;"}, // F1  0328  RIGHT HOOK, OGONEK / COMBINING OGONEK 
	{242, 0, "&#803;"}, // F2  0323  DOT BELOW / COMBINING DOT BELOW 
	{243, 0, "&#804;"}, // F3  0324  DOUBLE DOT BELOW / COMBINING DIAERESIS BELOW 
	{244, 0, "&#805;"}, // F4  0325  CIRCLE BELOW / COMBINING RING BELOW 
	{245, 0, "&#819;"}, // F5  0333  DOUBLE UNDERSCORE / COMBINING DOUBLE LOW LINE 
	{246, 0, "&#818;"}, // F6  0332  UNDERSCORE / COMBINING LOW LINE 
	{247, 0, "&#806;"}, // F7  0326  LEFT HOOK (COMMA BELOW) / COMBINING COMMA BELOW 
	{248, 0, "&#796;"}, // F8  031C  RIGHT CEDILLA / COMBINING LEFT HALF RING BELOW
	{249, 0, "&#814;"}, // F9  032E  UPADHMANIYA / COMBINING BREVE BELOW 
	{250, 0, "&#65058;"}, // FA  FE22  DOUBLE TILDE, FIRST HALF / COMBINING DOUBLE TILDE LEFT HALF
	{251, 0, "&#65059;"}, // FB  FE23  DOUBLE TILDE, SECOND HALF / COMBINING DOUBLE TILDE RIGHT HALF 
	{252, 0, 0},
	{253, 0, 0},
	{254, 0, "&#787;"}, // FE 0313 HIGH COMMA, CENTERED / COMBINING COMMA ABOVE (Psili) 
	{255, 0, 0},
};



void MARC8_XMLEntity::Encode(MARCStringBuffer & buf, const MARC_String & ms)
{
	int i = 0;
	int c = 0;

	while(i < ms.StringLength)
	{
		c = (unsigned char)ms.StringPtr[i];
		if(c < 127)
		{
			switch(c)
			{
	/*		case 27: //excape
			{
			int e = (unsigned char)ms.StringPtr[i + 1];
			switch(e)
			{
			case 103: // 0x67  Greek symbol set


			case 98: // 0x62 the Subscript set
			case 112: //0x70  the Superscript set
	
			default:
				break;

			}

			}
				break;*/
			case 38:
				buf.Append("&amp;");
				break;
			case 60:
				buf.Append("&lt;");
				break;
			case 62:
				buf.Append("&gt;");
				break;
			default:
				buf.Append((char)c);
			break;
			}
		}
		else
		{
		buf.Append(GetXMLNumericEntity(c));
		}
	++i;
	}
}

