/****************************************************
	MARC Template Library 

	Version 0.6.2 - Released 14 June 2002
	Version 0.6.1 - Released 12 June 2002
    Version 0.6 - Released 10 June 2002
	 Version 0.5 - Not Released 1st June 2002
    Version 0.4.5 - Released 5th April 2002
	Version 0.4 - Released 28th March 2002
	Version 0.3 - Released 18th January 2002
	Version 0.2 - Released 14th January 2002
	Version 0.1 - Released 8th January 2002


	Copyright Mark Basedow 2002.
	Email: markbasedow@bigpond.com

	Please read licence.txt that is
	distributed with this file.

  ***************************************************/


#ifndef _MARCWSTRINGBUFFER_H
#define _MARCWSTRINGBUFFER_H

#include <string>
#include "marcstring.h"
#include "marctag.h"


using namespace std;


class MARCWStringBuffer  
{
public:

	MARCWStringBuffer(long lInitialSize = 1000);
	MARCWStringBuffer(const MARCWStringBuffer & fsb);
	virtual ~MARCWStringBuffer();


	void Append(const char * szStr);
	void Append(char c);
	void Append(wchar_t c);
	void Append(long l);
	void Append(int i);
	void Append(const MARCWStringBuffer & fsb);
	void Append(MARC_WString & ms);
	void Append(const char * szStr, int iLen);
	void Append(MARCTag & mt);
	void AppendANSELEncode(MARC_String & ms);

//	void Insert(const char * szStr, long lOffset = 0);

	wchar_t * GetBuffer() { return buffer; }
	long GetBufferLength() { return lEnd; }

	MARCWStringBuffer & operator=(const MARCWStringBuffer & fcb);
	MARCWStringBuffer operator+(MARCWStringBuffer & fcb);

private:

	wchar_t * buffer;
	long lLength;
	long lEnd;
};




#endif 